package com.example.supermanoul.swimncoach.Fragments;


import android.content.DialogInterface;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.PorterDuff;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AlertDialog;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.helper.ItemTouchHelper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import com.example.supermanoul.swimncoach.POJO.Group;
import com.example.supermanoul.swimncoach.POJO.Student;
import com.example.supermanoul.swimncoach.POJO.TrainingSession;
import com.example.supermanoul.swimncoach.R;
import com.example.supermanoul.swimncoach.activities.Aplicacion;
import com.example.supermanoul.swimncoach.activities.MainActivity;
import com.example.supermanoul.swimncoach.adapters.StudentsAdapter;
import com.google.firebase.database.ChildEventListener;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.ValueEventListener;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import static com.facebook.FacebookSdk.getApplicationContext;


/**
 * A simple {@link Fragment} subclass.
 */
public class AddGroupFragment extends Fragment implements OnClickListener, ChildEventListener{

    private RecyclerView recyclerViewStudents;
    private StudentsAdapter adapterStudents;
    private RecyclerView.LayoutManager layoutManagerStudents;
    private String groupName;
    private Bundle bundle;

    //READS FROM THIS REFERENCE TO SHOW IN THE RECYCLERVIEW
    private DatabaseReference studentsReference;
    private DatabaseReference groupsReference;
    private DatabaseReference TSreference;
    private DatabaseReference TSreference2;
    private DatabaseReference studentStatsReference;

    private List<Group> groups = Collections.emptyList();
    private ArrayList<String> keys = new ArrayList<String>();
    private ArrayList<DataSnapshot> items = new ArrayList<DataSnapshot>();




    public AddGroupFragment() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {


        // Inflate the layout for this fragment
        View addGroupFragmentLayout = inflater.inflate(R.layout.fragment_add_group, container, false);
        recyclerViewStudents = (RecyclerView) addGroupFragmentLayout.findViewById(R.id.recycler_view_addgroup);

        recyclerViewStudents.setHasFixedSize(true);

        layoutManagerStudents = new LinearLayoutManager(getActivity());
        recyclerViewStudents.setLayoutManager(layoutManagerStudents);


        // FAB to add student
        FloatingActionButton fabAddStudent = (FloatingActionButton) addGroupFragmentLayout.findViewById(R.id.fab_addgroup_addstudents);
        fabAddStudent.bringToFront();
        fabAddStudent.setOnClickListener(this);

        // Delete group button
        Button buttonDeleteGroup = (Button) addGroupFragmentLayout.findViewById(R.id.deleteGroupButton);
        buttonDeleteGroup.setOnClickListener(this);

        // Save group button
        Button buttonSaveGroup = (Button) addGroupFragmentLayout.findViewById(R.id.saveGroupButton);
        buttonSaveGroup.setOnClickListener(this);

        // Set title bar
        ((MainActivity) getActivity()).setActionBarTitle(getActivity().getString(R.string.fragment_title_editGroup));

        //Get groupName and set it
        bundle = this.getArguments();
        if(bundle != null){
            groupName = bundle.getString("groupName");
        }


        TextView textView = (TextView) addGroupFragmentLayout.findViewById(R.id.groupName);
        textView.setText(groupName);

        // Set adapter and recyclerview
        studentsReference = ((Aplicacion) getApplicationContext()).getStudentsReference().child(groupName);
        groupsReference = ((Aplicacion) getApplicationContext()).getGroupsReference().child(groupName);
        TSreference = ((Aplicacion) getApplicationContext()).getTrainingSessionsReference().child(groupName);
        TSreference2 = ((Aplicacion) getApplicationContext()).getTrainingSessionsReference().child("ALL");
        studentStatsReference = ((Aplicacion) getApplicationContext()).getStudentsStatsReference();
        adapterStudents = new StudentsAdapter(getActivity(), studentsReference);
        recyclerViewStudents.setAdapter(adapterStudents);

        setUpItemTouchHelper();
        setUpAnimationDecoratorHelper();

        studentsReference.addChildEventListener(this);

        return addGroupFragmentLayout;
    }

    public void onClick(View v) {


        switch (v.getId()){
            case R.id.fab_addgroup_addstudents:
                AddStudentToGroupFragment fragment = new AddStudentToGroupFragment();
                fragment.setArguments(bundle);
                FragmentTransaction ft = getFragmentManager().beginTransaction();
                ft.replace(R.id.fragment_container, fragment);
                ft.addToBackStack(null);
                ft.commit();
                break;

            case R.id.deleteGroupButton:

                deletegroup();
                break;

            case R.id.saveGroupButton:

                GroupsFragment groupsFragment = new GroupsFragment();
                FragmentTransaction ftgroups;
                ftgroups = getFragmentManager().beginTransaction();
                ftgroups.replace(R.id.fragment_container, groupsFragment);
                ftgroups.addToBackStack(null);
                ftgroups.commit();
                break;


        }


    }

    @Override
    public void onChildAdded(DataSnapshot dataSnapshot, String s) {
        if(!dataSnapshot.getKey().equals("ALL")){
            items.add(dataSnapshot);
            keys.add(dataSnapshot.getKey());
        }

    }

    @Override
    public void onChildChanged(DataSnapshot dataSnapshot, String s) {
        String key = dataSnapshot.getKey();
        int index = keys.indexOf(key);
        if (index != -1) {
            items.set(index, dataSnapshot);
        }
    }

    @Override
    public void onChildRemoved(DataSnapshot dataSnapshot) {
        String key = dataSnapshot.getKey();
        int index = keys.indexOf(key);
        DatabaseReference noGroupReference = ((Aplicacion) getApplicationContext()).getStudentsReference().child("NO_GROUP").child(key);
        noGroupReference.setValue(getItem(index));

        if (index != -1) {
            keys.remove(index);
            items.remove(index);
        }
    }

    @Override
    public void onChildMoved(DataSnapshot dataSnapshot, String s) {
    }

    @Override
    public void onCancelled(DatabaseError databaseError) {
    }


    public DatabaseReference getRef(int pos) {
        return items.get(pos).getRef();
    }

    public Student getItem(int pos) {
        return items.get(pos).getValue(Student.class);
    }

    private void deletegroup(){
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        builder.setMessage(R.string.ad_confirmDeleteGroup);
        builder.setCancelable(true);

        // Training sessions from the group to remove
        final ArrayList<String> ts2remove = new ArrayList<>();

        // Add listener to get the training sessions from the group
        TSreference.addListenerForSingleValueEvent(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                for (DataSnapshot ds : dataSnapshot.getChildren()) {
                    TrainingSession ts = ds.getValue(TrainingSession.class);
                    if (!ts.isFinished()) {
                        ts2remove.add(ds.getKey());
                    }
                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });

        builder.setPositiveButton(
                R.string.ad_ok,
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {

                        //Remove group from database
                        groupsReference.removeValue();
                        studentsReference.removeValue();

                        // Remove training sessions of the group
                        //TSreference.removeValue();

                        // Remove training sessions from ALL group
                        for(int i=0;i<ts2remove.size();i++){
                            TSreference.child(ts2remove.get(i)).removeValue();
                            TSreference2.child(ts2remove.get(i)).removeValue();
                        }

                        dialog.cancel();

                        GroupsFragment groupsFragment = new GroupsFragment();
                        FragmentTransaction ftgroups;
                        ftgroups = getFragmentManager().beginTransaction();
                        ftgroups.replace(R.id.fragment_container, groupsFragment);
                        ftgroups.addToBackStack(null);
                        ftgroups.commit();
                    }
                });

        builder.setNegativeButton(
                R.string.cancel,
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.cancel();
                    }
                });

        AlertDialog alert = builder.create();
        alert.show();
    }

    /**
     * This is the standard support library way of implementing "swipe to delete" feature. You can do custom drawing in onChildDraw method
     * but whatever you draw will disappear once the swipe is over, and while the items are animating to their new position the recycler view
     * background will be visible. That is rarely an desired effect.
     */
    private void setUpItemTouchHelper() {

        ItemTouchHelper.SimpleCallback simpleItemTouchCallback = new ItemTouchHelper.SimpleCallback(0, ItemTouchHelper.LEFT) {

            // we want to cache these and not allocate anything repeatedly in the onChildDraw method
            Drawable background;
            Drawable xMark;
            int xMarkMargin = 50;
            boolean initiated;

            private void init() {
                background = new ColorDrawable(Color.RED);
                xMark = ContextCompat.getDrawable(getActivity(), R.drawable.ic_clear_black_24dp);
                xMark.setColorFilter(Color.WHITE, PorterDuff.Mode.SRC_ATOP);
                //xMarkMargin = (int) getActivity().getResources().getDimension(R.dimen.ic_clear_margin);
                initiated = true;
            }

            // not important, we don't want drag & drop
            @Override
            public boolean onMove(RecyclerView recyclerView, RecyclerView.ViewHolder viewHolder, RecyclerView.ViewHolder target) {
                return false;
            }

            @Override
            public int getSwipeDirs(RecyclerView recyclerView, RecyclerView.ViewHolder viewHolder) {
                return super.getSwipeDirs(recyclerView, viewHolder);
            }

            // When swiped an student
            @Override
            public void onSwiped(RecyclerView.ViewHolder viewHolder, int swipeDir) {
                int swipedPosition = viewHolder.getAdapterPosition();
                final Student studentRemoved = adapterStudents.getItem(swipedPosition);

                // Delete the swiped student
                deleteStudentFromGroup(studentRemoved);
                adapterStudents.notifyDataSetChanged();


            }

            @Override
            public void onChildDraw(Canvas c, RecyclerView recyclerView, RecyclerView.ViewHolder viewHolder, float dX, float dY, int actionState, boolean isCurrentlyActive) {
                View itemView = viewHolder.itemView;

                // not sure why, but this method get's called for viewholder that are already swiped away
                if (viewHolder.getAdapterPosition() == -1) {
                    // not interested in those
                    return;
                }

                if (!initiated) {
                    init();
                }

                // draw red background
                background.setBounds(itemView.getRight() + (int) dX, itemView.getTop(), itemView.getRight(), itemView.getBottom());
                background.draw(c);

                // draw x mark
                int itemHeight = itemView.getBottom() - itemView.getTop();
                int intrinsicWidth = xMark.getIntrinsicWidth();
                int intrinsicHeight = xMark.getIntrinsicWidth();

                int xMarkLeft = itemView.getRight() - xMarkMargin - intrinsicWidth;
                int xMarkRight = itemView.getRight() - xMarkMargin;
                int xMarkTop = itemView.getTop() + (itemHeight - intrinsicHeight)/2;
                int xMarkBottom = xMarkTop + intrinsicHeight;
                xMark.setBounds(xMarkLeft, xMarkTop, xMarkRight, xMarkBottom);

                xMark.draw(c);

                super.onChildDraw(c, recyclerView, viewHolder, dX, dY, actionState, isCurrentlyActive);
            }

        };
        ItemTouchHelper mItemTouchHelper = new ItemTouchHelper(simpleItemTouchCallback);
        mItemTouchHelper.attachToRecyclerView(recyclerViewStudents);
    }

    /**
     * We're gonna setup another ItemDecorator that will draw the red background in the empty space while the items are animating to thier new positions
     * after an item is removed.
     */
    private void setUpAnimationDecoratorHelper() {
        recyclerViewStudents.addItemDecoration(new RecyclerView.ItemDecoration() {

            // we want to cache this and not allocate anything repeatedly in the onDraw method
            Drawable background;
            boolean initiated;

            private void init() {
                background = new ColorDrawable(Color.RED);
                initiated = true;
            }

            @Override
            public void onDraw(Canvas c, RecyclerView parent, RecyclerView.State state) {

                if (!initiated) {
                    init();
                }

                // only if animation is in progress
                if (parent.getItemAnimator().isRunning()) {

                    // some items might be animating down and some items might be animating up to close the gap left by the removed item
                    // this is not exclusive, both movement can be happening at the same time
                    // to reproduce this leave just enough items so the first one and the last one would be just a little off screen
                    // then remove one from the middle

                    // find first child with translationY > 0
                    // and last one with translationY < 0
                    // we're after a rect that is not covered in recycler-view views at this point in time
                    View lastViewComingDown = null;
                    View firstViewComingUp = null;

                    // this is fixed
                    int left = 0;
                    int right = parent.getWidth();

                    // this we need to find out
                    int top = 0;
                    int bottom = 0;

                    // find relevant translating views
                    int childCount = parent.getLayoutManager().getChildCount();
                    for (int i = 0; i < childCount; i++) {
                        View child = parent.getLayoutManager().getChildAt(i);
                        if (child.getTranslationY() < 0) {
                            // view is coming down
                            lastViewComingDown = child;
                        } else if (child.getTranslationY() > 0) {
                            // view is coming up
                            if (firstViewComingUp == null) {
                                firstViewComingUp = child;
                            }
                        }
                    }

                    if (lastViewComingDown != null && firstViewComingUp != null) {
                        // views are coming down AND going up to fill the void
                        top = lastViewComingDown.getBottom() + (int) lastViewComingDown.getTranslationY();
                        bottom = firstViewComingUp.getTop() + (int) firstViewComingUp.getTranslationY();
                    } else if (lastViewComingDown != null) {
                        // views are going down to fill the void
                        top = lastViewComingDown.getBottom() + (int) lastViewComingDown.getTranslationY();
                        bottom = lastViewComingDown.getBottom();
                    } else if (firstViewComingUp != null) {
                        // views are coming up to fill the void
                        top = firstViewComingUp.getTop();
                        bottom = firstViewComingUp.getTop() + (int) firstViewComingUp.getTranslationY();
                    }

                    background.setBounds(left, top, right, bottom);
                    background.draw(c);

                }
                super.onDraw(c, parent, state);
            }

        });
    }

    private void deleteStudentFromGroup(final Student student){
        studentsReference.addListenerForSingleValueEvent(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                for (DataSnapshot ds: dataSnapshot.getChildren()) {
                    if (EncodeString(student.getId()).equals(ds.getKey())) {
                        studentsReference.child(EncodeString(student.getId())).removeValue();
                        break;
                    }

                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }

        });

    }

    // Replaces '.' with ',' to store in the database
    private static String EncodeString(String string) {
        return string.replace(".", ",");
    }

}
