package com.example.supermanoul.swimncoach.Fragments;


import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.design.widget.FloatingActionButton;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentTransaction;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CalendarView;

import com.example.supermanoul.swimncoach.R;
import com.example.supermanoul.swimncoach.activities.Aplicacion;
import com.example.supermanoul.swimncoach.activities.MainActivity;
import com.example.supermanoul.swimncoach.adapters.MainAdapter;
import com.google.firebase.database.DatabaseReference;

import java.text.SimpleDateFormat;
import java.util.Date;

import static com.facebook.FacebookSdk.getApplicationContext;


/**
 * A simple {@link Fragment} subclass.
 */
public class MainFragment extends Fragment implements View.OnClickListener{

    private CalendarView calendar;
    private DatabaseReference TSreference = ((Aplicacion) getApplicationContext()).getTrainingSessionsReference().child("ALL");
    private String dateSelected = "";
    private RecyclerView recyclerViewTS;
    private MainAdapter adapterMain;
    private RecyclerView.LayoutManager layoutManagerMain;
    private FloatingActionButton fabTSMain;

    public MainFragment() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        // Inflate the layout for this fragment
        View mainFragmentLayout = inflater.inflate(R.layout.fragment_main, container, false);

        // Get references from layout
        calendar = (CalendarView) mainFragmentLayout.findViewById(R.id.calendarView);
        recyclerViewTS = (RecyclerView) mainFragmentLayout.findViewById(R.id.recycler_view_ts_main);
        fabTSMain = (FloatingActionButton) mainFragmentLayout.findViewById(R.id.fab_training_sessions_main);


        // Setup calendar
        setupCalendar();

        // Listener for floating action button
        fabTSMain.setOnClickListener(this);
        fabTSMain.bringToFront();


        recyclerViewTS.setHasFixedSize(true);

        layoutManagerMain = new LinearLayoutManager(getActivity());
        recyclerViewTS.setLayoutManager(layoutManagerMain);

        recyclerViewTS.setOnClickListener(this);


        // Set title bar
        ((MainActivity) getActivity()).setActionBarTitle(getActivity().getString(R.string.fragment_title_home));


        return mainFragmentLayout;
    }

    private void setupCalendar(){
        SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy");
        dateSelected = sdf.format(new Date(calendar.getDate()));
        adapterMain = new MainAdapter(getActivity(), TSreference, dateSelected);
        recyclerViewTS.setAdapter(adapterMain);

        calendar.setOnDateChangeListener(new CalendarView.OnDateChangeListener() {
            @Override
            public void onSelectedDayChange(@NonNull CalendarView view, int year, int month, int dayOfMonth) {
                month++;

                String monthString = Integer.toString(month);
                String dayString =Integer.toString(dayOfMonth);

                if (month < 11){
                    monthString = "0"+monthString;
                }
                if (dayOfMonth < 10){
                    dayString = "0"+dayString;
                }

                dateSelected = dayString+"-"+monthString+"-"+Integer.toString(year);

                adapterMain = new MainAdapter(getActivity(), TSreference, dateSelected);
                recyclerViewTS.setAdapter(adapterMain);

            }
        });

    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.fab_training_sessions_main){

            //Send group's name to next fragment
            Bundle b = new Bundle();
            b.putString("date", dateSelected);
            AddTrainingSessionFragment fragment = new AddTrainingSessionFragment();
            fragment.setArguments(b);
            FragmentTransaction ft = getFragmentManager().beginTransaction();
            ft.replace(R.id.fragment_container, fragment);
            ft.addToBackStack(null);
            ft.commit();
        }

    }
}
