package com.example.supermanoul.swimncoach.Fragments;


import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.example.supermanoul.swimncoach.R;
import com.example.supermanoul.swimncoach.activities.Aplicacion;
import com.example.supermanoul.swimncoach.activities.MainActivity;
import com.example.supermanoul.swimncoach.adapters.ResultsAdapter;
import com.google.firebase.database.DatabaseReference;

import static com.facebook.FacebookSdk.getApplicationContext;


/**
 * A simple {@link Fragment} subclass.
 */
public class ShowResultsFragment extends Fragment {

    private TextView dateTV;
    private TextView groupNameTV;
    private RecyclerView recyclerViewResults;
    private RecyclerView.Adapter adapterResults;
    private RecyclerView.LayoutManager layoutManagerResults;
    private Bundle bundle;
    private String trainingSessionID = "";
    private String groupName = "";

    private DatabaseReference resultsReference;

    public ShowResultsFragment() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View resultsFragmentLayout = inflater.inflate(R.layout.fragment_show_results, container, false);

        recyclerViewResults = (RecyclerView) resultsFragmentLayout.findViewById(R.id.recycler_view_results);

        // use this setting to improve performance if you know that changes
        // in content do not change the layout size of the RecyclerView
        recyclerViewResults.setHasFixedSize(true);

        // use a linear layout manager
        layoutManagerResults = new LinearLayoutManager(getActivity());
        recyclerViewResults.setLayoutManager(layoutManagerResults);

        bundle = this.getArguments();
        if (bundle != null){
            trainingSessionID = bundle.getString("training_session_id");
            groupName = bundle.getString("groupName");
        }

        groupNameTV = (TextView) resultsFragmentLayout.findViewById(R.id.groupNameResults);
        dateTV = (TextView) resultsFragmentLayout.findViewById(R.id.dateTSResults);

        groupNameTV.setText(String.format(getActivity().getString(R.string.ts_groupName), groupName));
        String [] parts = trainingSessionID.split("_");
        dateTV.setText(parts[0]+", "+parts[1]);

        resultsReference = ((Aplicacion) getApplicationContext()).getTrainingSessionsReference().child("ALL").child(trainingSessionID).child("results");

        // specify an adapter (see also next example)
        adapterResults = new ResultsAdapter(getActivity(), resultsReference);
        recyclerViewResults.setAdapter(adapterResults);


        // Set title bar
        ((MainActivity) getActivity()).setActionBarTitle(getActivity().getString(R.string.fragment_title_results));

        return resultsFragmentLayout;

    }




}
