package com.example.supermanoul.swimncoach.Fragments;


import android.os.Bundle;
import android.os.CountDownTimer;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.helper.ItemTouchHelper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import com.example.supermanoul.swimncoach.POJO.TrainingSession;
import com.example.supermanoul.swimncoach.R;
import com.example.supermanoul.swimncoach.activities.Aplicacion;
import com.example.supermanoul.swimncoach.activities.MainActivity;
import com.example.supermanoul.swimncoach.adapters.TrainingSessionSelectedAdapter;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseReference;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.List;

import static com.facebook.FacebookSdk.getApplicationContext;

/**
 * A simple {@link Fragment} subclass.
 */
public class TrainingSessionSelectedFragment extends Fragment {

    private String id;
    private String date;
    private String time;
    private String groupName;
    private int poolLength;
    private int duration;
    private Bundle bundle;
    private TrainingSession trainingSession;

    private Button endSessionButton;
    private TextView groupNameTextView;
    private TextView countdownTextView;
    private TextView dateAndTimeTextView;
    private RecyclerView TSselectedRecyclerView;
    private RecyclerView.LayoutManager layoutManagerTSSelected;

    private TrainingSessionSelectedAdapter adapterTS;

    private List<TrainingSession> trainingSessions = Collections.emptyList();
    private ArrayList<String> keys = new ArrayList<String>();
    private ArrayList<DataSnapshot> items = new ArrayList<DataSnapshot>();
    
    private DatabaseReference studentsReference;

    private CountDownTimer timer;

    private String timeRemaining = "";




    public TrainingSessionSelectedFragment() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        // Inflate the layout for this fragment
        View trainingSessionSelectedLayout = inflater.inflate(R.layout.fragment_training_session_selected, container, false);



        //Get training sessions info
        bundle = this.getArguments();
        if(bundle != null){
            id = bundle.getString("id");
            date = bundle.getString("date");
            time = bundle.getString("time");
            groupName = bundle.getString("groupName");
            poolLength = bundle.getInt("poolLength");
            duration = bundle.getInt("duration");

            trainingSession = new TrainingSession(id, date, time, groupName, poolLength, duration, false);
        }

        // Set title bar
        ((MainActivity) getActivity()).setActionBarTitle(getString(R.string.fragment_title_trainingSessionSelected));

        // Setup timer
        setUpTimer();

        //Initialize references
        endSessionButton = (Button) trainingSessionSelectedLayout.findViewById(R.id.endSessionButton);
        groupNameTextView = (TextView) trainingSessionSelectedLayout.findViewById(R.id.groupNameTSSelectedTextView);
        countdownTextView = (TextView) trainingSessionSelectedLayout.findViewById(R.id.countdownTimeTextView);
        dateAndTimeTextView = (TextView) trainingSessionSelectedLayout.findViewById(R.id.dateAndTimeTSSelectedTextView);
        TSselectedRecyclerView = (RecyclerView) trainingSessionSelectedLayout.findViewById(R.id.recycler_view_ts_selected);

        //endSessionButton.setOnClickListener(this);
        
        //Set recyclerview, adapter, database reference
        
        TSselectedRecyclerView.setHasFixedSize(true);
        
        layoutManagerTSSelected = new LinearLayoutManager(getActivity());
        TSselectedRecyclerView.setLayoutManager(layoutManagerTSSelected);
        
        studentsReference = ((Aplicacion) getApplicationContext()).getStudentsReference().child(groupName);


        adapterTS = new TrainingSessionSelectedAdapter(getActivity(), studentsReference, timer, trainingSession, getActivity(), endSessionButton, getFragmentManager());
        TSselectedRecyclerView.setAdapter(adapterTS);
        setUpItemTouchHelper();


        //Set variables
        String groupNameString = getApplicationContext().getResources().getString(R.string.ts_groupName);
        groupNameTextView.setText(String.format(groupNameString, groupName));
        dateAndTimeTextView.setText(date + ", "+time+ "h");
        if (duration < 10){
            countdownTextView.setText("0"+ Integer.toString(duration) + ":00");
        }
        else{
            countdownTextView.setText(Integer.toString(duration) + ":00");
        }

        return trainingSessionSelectedLayout;
    }



    private void setUpItemTouchHelper() {

        // Extend the Callback class
        ItemTouchHelper.Callback _ithCallback = new ItemTouchHelper.Callback() {

            public boolean onMove(RecyclerView recyclerView, RecyclerView.ViewHolder viewHolder, RecyclerView.ViewHolder target) {
                // get the viewHolder's and target's positions in your adapter data, swap them
                Collections.swap(adapterTS.getStudentsInTS(), viewHolder.getAdapterPosition(), target.getAdapterPosition());
                // and notify the adapter that its dataset has changed
                adapterTS.notifyItemMoved(viewHolder.getAdapterPosition(), target.getAdapterPosition());
                return true;
            }

            @Override
            public void onSwiped(RecyclerView.ViewHolder viewHolder, int direction) {
                //TODO
            }

            //defines the enabled move directions in each state (idle, swiping, dragging).
            @Override
            public int getMovementFlags(RecyclerView recyclerView, RecyclerView.ViewHolder viewHolder) {
                int dragFlags = ItemTouchHelper.UP | ItemTouchHelper.DOWN;
                return makeMovementFlags(dragFlags, 0);
            }
        };

        // Create an `ItemTouchHelper` and attach it to the `RecyclerView`
        ItemTouchHelper ith = new ItemTouchHelper(_ithCallback);
        ith.attachToRecyclerView(TSselectedRecyclerView);
    }

    private void setUpTimer(){
        timer = new CountDownTimer(duration*60*1000, 100) {
            SimpleDateFormat formatter = new SimpleDateFormat("mm:ss.S");


            @Override
            public void onTick(long millisUntilFinished) {

                countdownTextView.setText(formatter.format(new Date(millisUntilFinished)));


            }

            @Override
            public void onFinish() {
                adapterTS.setTimerEnded(true);
                System.out.println("TIMER FINALIZADO");
                countdownTextView.setText("00:00.0");
            }

        };

    }


    /*
    //Onclick
    @Override
    public void onClick(View v) {
        if(v.getId() == R.id.endSessionButton){
            System.out.println("LLEGO A CLICK");
        }

    }
    */

}

