package com.example.supermanoul.swimncoach.activities;

import android.app.Application;

import com.google.firebase.FirebaseApp;
import com.google.firebase.FirebaseOptions;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;



public class Aplicacion extends Application {

    private FirebaseAuth auth;

    private FirebaseAuth auth2;

    private FirebaseDatabase database;

    private final static String COACHES = "coaches";
    private final static String STUDENTS = "students";
    private final static String GROUPS = "groups";
    private final static String STUDENTSTATS = "studentStats";
    private final static String TRAININGSESSIONS = "trainingSessions";

    private DatabaseReference coachesReference;
    private DatabaseReference studentsReference;
    private DatabaseReference groupsReference;
    private DatabaseReference studentsStatsReference;
    private DatabaseReference trainingSessionsReference;

    @Override
    public void onCreate() {
        super.onCreate();
        auth = FirebaseAuth.getInstance();
        database = FirebaseDatabase.getInstance();
        database.setPersistenceEnabled(true);
        coachesReference = database.getReference().child(COACHES);
        studentsStatsReference = database.getReference().child(STUDENTSTATS);

        // Second firebaseauth init
        FirebaseOptions firebaseOptions = new FirebaseOptions.Builder()
                .setDatabaseUrl("https://swimncoach.firebaseio.com/")
                .setApiKey("AIzaSyC6gQ2R9g-IDqk2C24B3hNkF__dMgny2UY")
                .setApplicationId("swimncoach").build();

        FirebaseApp myApp = FirebaseApp.initializeApp(getApplicationContext(), firebaseOptions, "SwimNCoach");
        auth2 = FirebaseAuth.getInstance(myApp);

    }

    public FirebaseAuth getAuth() {
        return auth;
    }

    public FirebaseAuth getAuth2() { return auth2; }


    public DatabaseReference getCoachesReference() {
        return coachesReference;
    }

    public DatabaseReference getStudentsReference() {
        return studentsReference;
    }

    public DatabaseReference getGroupsReference() {
        return groupsReference;
    }

    public DatabaseReference getStudentsStatsReference() {return studentsStatsReference; }

    public DatabaseReference getTrainingSessionsReference() {return trainingSessionsReference; }

    public void initReferences(){
        studentsReference = database.getReference().child(STUDENTS).child(auth.getCurrentUser().getUid());
        groupsReference = database.getReference().child(GROUPS).child(auth.getCurrentUser().getUid());
        trainingSessionsReference = database.getReference().child(TRAININGSESSIONS).child(auth.getCurrentUser().getUid());
    }

    public  DatabaseReference getDatabaseReference(){
        return database.getReference();
    }
}
