package com.example.supermanoul.swimncoach.activities;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;

import com.example.supermanoul.swimncoach.POJO.Coach;
import com.example.supermanoul.swimncoach.R;
import com.firebase.ui.auth.AuthUI;
import com.firebase.ui.auth.ResultCodes;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.FirebaseUser;
import com.google.firebase.database.DatabaseReference;

import java.util.Arrays;

public class LoginActivity extends AppCompatActivity {

    private static final int RC_SIGN_IN = 123;
    public static final String USER_PREFERENCES = "userPreferences";
    private FirebaseAuth auth;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);
        auth = ((Aplicacion) getApplicationContext()).getAuth();
        doLogin();
    }


    private void doLogin() {
        FirebaseUser currentUser = auth.getCurrentUser();
        if (currentUser != null) {
            ((Aplicacion) getApplicationContext()).initReferences();
            saveUser(currentUser);
            String name = currentUser.getDisplayName();
            String email = currentUser.getEmail();
            String provider = currentUser.getProviders().get(0);
            String uid = currentUser.getUid();
            String photoUrl = null;
            try{
                photoUrl = currentUser.getPhotoUrl().toString();
            } catch (Exception e){
                Log.d("noImage", "There user has no picture");}

            SharedPreferences.Editor editor = getSharedPreferences(USER_PREFERENCES, MODE_PRIVATE).edit();
            editor.putString("name", name).commit();
            editor.putString("provider", provider).commit();
            editor.putString("uid", uid).commit();
            if (email != null) {
                editor.putString("email", email).commit();
            }

            if(photoUrl != null){
                editor.putString("photoUrl", photoUrl).commit();
            }

            //Launch MainActivity
            Intent i = new Intent(this, MainActivity.class);
            i.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP
                    | Intent.FLAG_ACTIVITY_NEW_TASK
                    | Intent.FLAG_ACTIVITY_CLEAR_TASK); startActivity(i);

        } else {
            startActivityForResult(AuthUI.getInstance()
                .createSignInIntentBuilder().setProviders(Arrays.asList(
                        new AuthUI.IdpConfig.Builder(AuthUI.EMAIL_PROVIDER).build(),
                        new AuthUI.IdpConfig.Builder(AuthUI.GOOGLE_PROVIDER).build()))
                .setIsSmartLockEnabled(true).build(), RC_SIGN_IN);
        }
    }
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data); if (requestCode == RC_SIGN_IN) {
            if (resultCode == ResultCodes.OK) { doLogin();
                finish(); }
        } }

    void saveUser(final FirebaseUser user) {
        DatabaseReference coachReference=((Aplicacion) getApplicationContext()).getCoachesReference().child(user.getUid());
        coachReference.setValue(new Coach(user.getDisplayName(), user.getEmail()));
    }

}

